PolyRing constructor: NewOrdvArith computed twice

17 May 2017 10:35 - Anna Maria Bigatti

Status: In Progress Start date: 17 May 2017

Priority: Normal Due date:  

Assignee:  % Done: 10%

Category: enhancing/improving Estimated time: 0.00 hour

Target version: CoCoA-5.?.? Spent time: 0.85 hour

Description

We never considered that a slow ring constructor could be a problem, but may be.

In particular this bit of code:

  RingDistrMPolyInlFpPPImpl::RingDistrMPolyInlFpPPImpl(const ring& R, const std::vector<symbol>& I

ndetNames, const PPOrdering& ord):

    myCoeffRingValue(R),

    myInlineCoeffImplValue(ConvertTo<long>(characteristic(R))),

    myPPMValue(NewPPMonoidOv(IndetNames, ord)),

    myOrdvArith(NewOrdvArith(ord)),

computes NewOrdvArith twice, the first one in NewPPMonoidOv.

Related issues:

Related to CoCoALib - Slug #1057: Slug: Polynomial ring contructor slow with ... In Progress 04 May 2017

Related to CoCoALib - Bug #1641: gcd does not recognize univariate input Closed 20 Dec 2021

History

#1 - 17 May 2017 10:36 - Anna Maria Bigatti

- Related to Slug #1057: Slug: Polynomial ring contructor slow with (big) matrix ordering added

#2 - 17 May 2017 11:19 - Anna Maria Bigatti

- Status changed from New to In Progress

- % Done changed from 0 to 10

It would be handy to get the OrdvArith from a PPMonoid (if possible).

This could also be used internally by the GBasis-like operations, which recreate their own rings with the same ordering as the ring of the input.

(this might speed up GroebnerFan in the case of easy but many GBs)

#3 - 17 May 2017 11:33 - Anna Maria Bigatti

Anna Maria Bigatti wrote:

It would be handy to get the OrdvArith from a PPMonoid (if possible).

 

If John allows me ;-) I implement it, and test if this solves all ring contructor slugs.
#4 - 17 May 2017 11:40 - John Abbott

OK, Anna; take a look.

I'm a bit busy with other things right now.

#5 - 21 Mar 2024 11:54 - Anna Maria Bigatti

- Related to Bug #1641: gcd does not recognize univariate input  added

#6 - 21 Mar 2024 11:55 - Anna Maria Bigatti

I added some verbosity

/**/ SetVerbosityLevel(99);

/**/ P := NewPolyRingWeights(QQ, "x,y,z", RowMat([1,2,3]));

   [D1,L99,NewOrdvArith(ord)]  -- called --

    [D2,L99,MatrixOrdering32bitImpl ctor]  -- called --

   [D1,L99,PPMonoidOvImpl(syms,ord)]  -- called --

   [D1,L99,NewOrdvArith(ord)]  -- called --

    [D2,L99,MatrixOrdering32bitImpl ctor]  -- called --
